require "class.lua"

require "drawable.lua"

require "updatable.lua"
require "basicweapon"

playerWeaponsList = {}

playerWeaponsListRemove = {}


Player =

{
timeToNextShot = 0,
bulletImage
}


PlayerBuilder = createClass(Player, Updatable, Drawable)


function Player:new()
self.bulletImage = love.graphics.newImage("bullet.png")

end


function Player:update()
self.timeToNextShot = self.timeToNextShot - 1


if love.keyboard.isDown("left") then

self.x = self.x - 1

elseif love.keyboard.isDown("right") then

self.x = self.x + 1

end
if love.keyboard.isDown(" ") and self.timeToNextShot <= 0 then
self.timeToNextShot = 50

BasicWeaponBuilder:new(

{

image = self.bulletImage,

x = self.x + self.image:getWidth() / 2 - self.bulletImage:getWidth() / 2,

y = self.y - self.bulletImage:getHeight(),

z = self.z,

collection = playerWeaponsList,

removeCollection = playerWeaponsListRemove

}

)

end

end

